
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <errno.h>
#include <stdio.h>


int ML_PF_INET = PF_INET;
int ML_SOCK_STREAM = SOCK_STREAM;
int ML_MSG_NOSIGNAL = MSG_NOSIGNAL;
int ml_errno = 0;

int ml_get_errno() {
  return ml_errno;
}

int ml_bindport(int s, int p) {
  struct sockaddr_in addr;
      
  addr.sin_family = AF_INET;
  addr.sin_port = htons(p);
  addr.sin_addr.s_addr = 0; /* INADDR_ANY */
  memset(&(addr.sin_zero), '\0', 8);

  return bind(s, (struct sockaddr *)&addr, sizeof(struct sockaddr));
}

int ml_accept(int l) {
  struct sockaddr remote;
  int sin_size = sizeof (struct sockaddr_in);
  return accept(l, (struct sockaddr*)&remote, &sin_size);
}

int ml_connect(const char * a, int p) {

  int s;
  struct sockaddr_in dest;
  struct hostent * h;

  s = socket(AF_INET, SOCK_STREAM, 0);
  if (s < 0) return -1;

  if ((h = (struct hostent *)gethostbyname(a))) {
    dest.sin_addr = *((struct in_addr *)h->h_addr);
  } else dest.sin_addr.s_addr = inet_addr(a);
  
  /*
  printf("Connecting to IP: %d.%d.%d.%d \n",
	 255 & ((int)dest.sin_addr.s_addr >> 24),
	 255 & ((int)dest.sin_addr.s_addr >> 16),
	 255 & ((int)dest.sin_addr.s_addr >> 8),
	 255 & (int)dest.sin_addr.s_addr);
  */
  dest.sin_family = AF_INET;
  dest.sin_port = htons(p);

  memset(&(dest.sin_zero), 0, 8);

  connect(s, (struct sockaddr *) &dest, sizeof (struct sockaddr));

  return s;
}
